using System;

namespace Indexer.Engine.Parsers
{
	/* This parser works, but its output is not pretty
	public class RtfParser: IFilterParser
	{
		public RtfParser(): base(".rtf")
		{
		}
		
		public override bool Accepts(string fileName, byte[] previewBuffer)
		{
			return BufferStartsWith(previewBuffer, @"{\rtf");
		}
		
		public override void Initialize()
		{
			base.Initialize();
			RegisterIFilter("rtffilt.dll", new Guid("{e2403e98-663b-4df6-b234-687789db8560}"));
		}
	}
	*/
	public class RtfParser: ParserBase
	{
		public RtfParser(): base(".rtf")
		{
		}
		
		protected override bool GetSupportsCopy()
		{
			return true;
		}
		
		public override bool Accepts(string fileName, byte[] previewBuffer)
		{
			return BufferStartsWith(previewBuffer, @"{\rtf");
		}
		
		public override bool Accepts(string fileName, string previewBuffer)
		{
			return BufferStartsWith(previewBuffer, @"{\rtf");
		}
		
		public override void Copy(string fileName, System.IO.TextWriter output)
		{
			System.Windows.Forms.RichTextBox convertor = new System.Windows.Forms.RichTextBox();
			try
			{
				convertor.LoadFile(fileName, System.Windows.Forms.RichTextBoxStreamType.RichText);
				Writer writer = new Writer(output);
				try
				{
					foreach(string line in convertor.Lines)
					{
						writer.WriteLine(line);
					}
				}
				finally
				{
					writer.Close();
				}
			}
			finally
			{
				convertor.Dispose();
			}
		}
	}
}
