using System;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Soap;

namespace NUnit
{
	public class Comparer
	{
		private static byte[] Serialize(Object obj)
		{
			MemoryStream stream = new MemoryStream();
			SoapFormatter formatter = new SoapFormatter();
			formatter.Serialize(stream, obj);
			byte[] result = new byte[stream.Length];
			stream.Position = 0;
			stream.Read(result, 0, result.Length);
			return result;
		}

		public static void Dump(Object obj, string fileName)
		{
			Stream fs = new FileStream(fileName, FileMode.Create);
			try
			{
				SoapFormatter formatter = new SoapFormatter();
				formatter.Serialize(fs, obj);
			}
			finally
			{
				fs.Close();
			}
		}

		public static bool Equals(byte[] a, byte[] b)
		{
			if(a.Length != b.Length) return false;
			for(int i = 0; i < a.Length; i++)
			{
				if(a[i] != b[i]) return false;
			}
			return true;
		}

		public static new bool Equals(object a, object b)
		{
			if(a == null) return (b == null);
			if(b == null) return (a == null);
			if(a.Equals(b)) return true;
			try
			{
				return Equals(Serialize(a), Serialize(b));
			}
			catch(Exception)
			{
				return false;
			}
		}
	}
}
