using System;
using System.Reflection;
using Quest.Atomic;

namespace Quest.Atomic.Graph2D
{
	public class Node: Quest.Graph2D.Node
	{
		public Atom Data;

		public Node()
		{
		}

		public override string ID
		{
			get
			{
				if(Data == null)
				{
					return "";
				}
				else
				{
					return String.Format("{0}({1})", Data.GetType().Name, Data.ID);
				}
			}
		}

		public override string ReferenceID()
		{
			return ID;
		}

		public override bool Contains(string filterExpression) 
		{
			if(base.Contains(filterExpression)) 
			{
				return true;
			}
			foreach(FieldInfo info in AtomInfo.GetFields(Data, AtomInfo.FieldFlags.Editable))
			{
				if(Contains((string)info.GetValue(Data), filterExpression))
				{
					return true;
				}
			}
			return false;
		}
	}
}
