using System;
using Structure.Graph2D.IO;

namespace Structure.Graph2D.yWorks
{
	public class Constants
	{
		public static string Encode(NodeShape shape)
		{
			switch (shape)
			{
				case NodeShape.Rectangle:
					return "rectangle";
					
				case NodeShape.Rectangle3D:
					return "rectangle3d";
					
				case NodeShape.RoundRectangle:
					return "roundrectangle";
				
				default:
					throw new NotSupportedException(shape.ToString());
			}
		}
		
		private static string X2(int value)
		{
			string result = value.ToString("X");
			if (result.Length < 2)
			{
				return "0" + result;
			}
			else
			{
				return result;
			}
		}

		public static string Encode(System.Drawing.Color color)
		{
			return "#" + X2(color.R) + X2(color.G) + X2(color.B);
		}
		
		public static string Encode(ArrowStyle style)
		{
			switch (style)
			{
				case ArrowStyle.None:
					return "none";
					
				case ArrowStyle.Normal:
					return "standard";
					
				case ArrowStyle.Short:
					return "short";
					
				default:
					throw new NotSupportedException(style.ToString());
			}
		}
		
		public static string Encode(EdgeStyle style)
		{
			switch (style)
			{
				case EdgeStyle.Normal:
					return "line";
					
				case EdgeStyle.Dotted:
					return "dotted";
					
				case EdgeStyle.Dashed:
					return "dashed";
					
				default:
					throw new NotSupportedException(style.ToString());
			}
		}
		
		public static string Encode(bool value)
		{
			return value ? "true" : "false";
		}
		
		public static float EncodeFontSize(System.Drawing.Font font)
		{
			return (float)Math.Round((font.SizeInPoints * 96 /* DPI */) / 72 /* Point unit */);
		}
	}
	
	public class Tools
	{
		public Tools()
		{
		}
	}
}
