using System;

namespace System.Collections
{
	public class NullableBitArray
	{
		private System.Collections.MultiBitArray _flags;
		
		public NullableBitArray(int count)
		{
			_flags = new System.Collections.MultiBitArray(count, Value.MaxValue);
		}

		private class Value
		{
			public const int NotInitialized = 0;
			public const int True = 1;
			public const int False = 2;
			
			public const int MinValue = 0;
			public const int MaxValue = False;
		}
		
		public Nullable<bool> this[int index]
		{
			get 
			{
				switch (_flags[index])
				{
					case Value.NotInitialized:
						return null;
						
					case Value.True:
						return true;
						
					case Value.False:
						return false;
						
					default:
						// TODO: assert(false)
						throw new NotImplementedException();
				}
			}
			set 
			{
				if (!value.HasValue)
				{
					_flags[index] = Value.NotInitialized;
				}
				else if (value.Value)
				{
					_flags[index] = Value.True;
				}
				else
				{
					_flags[index] = Value.False;
				}
			}
		}
		
		public int Count 
		{
			get 
			{
				return _flags.Count;
			}
		}
	}
}
