using System;

namespace System.Data
{
	public class Xls
	{
		public static void SaveTable(DataTable table, string fileName)
		{
			SaveTable(table, null, fileName, null);
		}
		
		public static void SaveTable(DataTable table, IDataReader reader, string fileName, System.Threading.IProgress observer)
		{
			/* TODO: implement with text file with *.xls extension and content like this:
			 * <TABLE> 
			 * <th><h4>Just testing</h4></th>
			 * <TR><TD width="20">1</TD><TD width="30">2</TD><TD width="40">3</TD></TR>
			 * <TR><TD>4</TD><TD>4</TD><TD>6</TD></TR>
			 * <TR><TD>7</TD><TD>8</TD><TD>9</TD></TR>
			 * <TR><TD>=SUM(A3:A5)</TD><TD>=SUM(B3:B5)</TD><TD>=SUM(C3:C5)</TD></TR>
			 * </TABLE>
			 * 
			 * see http://www.rgagnon.com/javadetails/java-0586.html
			 */
			Common.DbBridge db = new Common.DbBridge(System.IO.Path.GetFullPath(fileName));
			try
			{
				string tableName = table.TableName;
				if (String.IsNullOrEmpty(tableName))
				{
					tableName = "Sheet1";
				}
				db.CreateTable(tableName, table, reader, observer);
			}
			finally
			{
				db.Dispose();
			}
		}
		
		public static DataTable LoadTable(string fileName, string tableName)
		{
			Common.DbBridge db = new Common.DbBridge(System.IO.Path.GetFullPath(fileName));
			try
			{
				return db.LoadTable(tableName);
			}
			finally
			{
				db.Dispose();
			}
		}
	}
}
