using System;

namespace System.Drawing
{
	public class IconHelper
	{
		public static Bitmap GetBitmap(Icon icon)
		{
			if (icon == null)
			{
				return null;
			}
			
			Bitmap result = new Bitmap(icon.Width, icon.Height);
			Graphics gc = Graphics.FromImage(result);
			try
			{
				gc.DrawIcon(icon, 0, 0);
			}
			finally
			{
				gc.Dispose();
			}
			return result;
		}
		
		public static Bitmap GetSmallBitmap(Icon icon)
		{
			if (icon == null)
			{
				return null;
			}
			
			Bitmap result = new Bitmap(16, 16);
			Graphics gc = Graphics.FromImage(result);
			try
			{
				gc.DrawIcon(icon, new Rectangle(0, 0, result.Width, result.Height));
			}
			finally
			{
				gc.Dispose();
			}
			return result;
		}
	}
}
