using System;

namespace System.Windows.Forms
{
	public enum UserProfile
	{
		Undefined,
		NonRoamingUser,
		RoamingUser
	}

	public class Environment
	{
		public static string GetFullPath(string fileName, UserProfile profile)
		{
			string basePath = null;
			switch (profile)
			{
				case UserProfile.NonRoamingUser:
					basePath = Application.LocalUserAppDataPath;
					break;

				case UserProfile.RoamingUser:
					basePath = Application.UserAppDataPath;
					break;
			}

			if (basePath != null)
			{
				try
				{
					// try deleting possibly newly created settings directory
					System.IO.Directory.Delete(basePath);
				}
				catch (Exception)
				{
					// if deletion failed, there were some files already in there
				}

				// remove version number component
				basePath = System.IO.Path.GetDirectoryName(basePath);
			}

			return System.IO.Path.Combine(basePath, fileName);
		}
	}
}
