using System;
using System.Runtime.InteropServices;

namespace System.Windows.Forms
{
	public class ConsoleHelper
	{
		[DllImport("kernel32.dll", EntryPoint="GetConsoleWindow")]
		private static extern IntPtr GetWindow();
		
		[DllImport("user32.dll", EntryPoint="ShowWindow")]
		private static extern bool ShowWindow(IntPtr hwnd,int nCmdShow);
		
		private const int SW_HIDE = 0;
		
		public static void Run(Form mainForm)
		{
			IntPtr consoleWindow = GetWindow();
			if (consoleWindow != IntPtr.Zero)
			{
				ShowWindow(consoleWindow, SW_HIDE);
			}
			Application.Run(mainForm);
		}
	}
}
